Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 228e490270cec3d6a6de666f61839f0d9ed5f193)
+++ kernel/generic/src/ipc/sysipc.c	(revision 97d17fe22e08421f3adcc9ab7e1cf8156055bd5d)
@@ -49,5 +49,4 @@
 #include <syscall/copy.h>
 #include <security/cap.h>
-#include <console/console.h>
 #include <mm/as.h>
 #include <print.h>
@@ -69,5 +68,5 @@
  *
  */
-static int phone_get(sysarg_t phoneid, phone_t **phone)
+static int phone_get(unative_t phoneid, phone_t **phone)
 {
 	if (phoneid >= IPC_MAX_PHONES)
@@ -78,15 +77,14 @@
 }
 
-/** Decide if the interface and method is a system method.
- *
- * @param imethod Interface and method to be decided.
- *
- * @return True if the interface and method is a system
- *         interface and method.
- *
- */
-static inline bool method_is_system(sysarg_t imethod)
-{
-	if (imethod <= IPC_M_LAST_SYSTEM)
+/** Decide if the method is a system method.
+ *
+ * @param method Method to be decided.
+ *
+ * @return true if the method is a system method.
+ *
+ */
+static inline bool method_is_system(unative_t method)
+{
+	if (method <= IPC_M_LAST_SYSTEM)
 		return true;
 	
@@ -94,17 +92,17 @@
 }
 
-/** Decide if the message with this interface and method is forwardable.
- *
- * Some system messages may be forwarded, for some of them
- * it is useless.
- *
- * @param imethod Interface and method to be decided.
- *
- * @return True if the interface and method is forwardable.
- *
- */
-static inline bool method_is_forwardable(sysarg_t imethod)
-{
-	switch (imethod) {
+/** Decide if the message with this method is forwardable.
+ *
+ * - some system messages may be forwarded, for some of them
+ *   it is useless
+ *
+ * @param method Method to be decided.
+ *
+ * @return true if the method is forwardable.
+ *
+ */
+static inline bool method_is_forwardable(unative_t method)
+{
+	switch (method) {
 	case IPC_M_CONNECTION_CLONE:
 	case IPC_M_CONNECT_ME:
@@ -117,16 +115,16 @@
 }
 
-/** Decide if the message with this interface and method is immutable on forward.
- *
- * Some system messages may be forwarded but their content cannot be altered.
- *
- * @param imethod Interface and method to be decided.
- *
- * @return True if the interface and method is immutable on forward.
- *
- */
-static inline bool method_is_immutable(sysarg_t imethod)
-{
-	switch (imethod) {
+/** Decide if the message with this method is immutable on forward.
+ *
+ * - some system messages may be forwarded but their content cannot be altered
+ *
+ * @param method Method to be decided.
+ *
+ * @return true if the method is immutable on forward.
+ *
+ */
+static inline bool method_is_immutable(unative_t method)
+{
+	switch (method) {
 	case IPC_M_SHARE_OUT:
 	case IPC_M_SHARE_IN:
@@ -154,5 +152,5 @@
 static inline bool answer_need_old(call_t *call)
 {
-	switch (IPC_GET_IMETHOD(call->data)) {
+	switch (IPC_GET_METHOD(call->data)) {
 	case IPC_M_CONNECTION_CLONE:
 	case IPC_M_CONNECT_ME:
@@ -198,5 +196,5 @@
 		return 0;
 	
-	if (IPC_GET_IMETHOD(*olddata) == IPC_M_CONNECTION_CLONE) {
+	if (IPC_GET_METHOD(*olddata) == IPC_M_CONNECTION_CLONE) {
 		int phoneid = IPC_GET_ARG1(*olddata);
 		phone_t *phone = &TASK->phones[phoneid];
@@ -220,5 +218,5 @@
 			mutex_unlock(&phone->lock);
 		}
-	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_CONNECT_ME) {
+	} else if (IPC_GET_METHOD(*olddata) == IPC_M_CONNECT_ME) {
 		phone_t *phone = (phone_t *) IPC_GET_ARG5(*olddata);
 		
@@ -239,5 +237,5 @@
 			mutex_unlock(&phone->lock);
 		}
-	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_CONNECT_TO_ME) {
+	} else if (IPC_GET_METHOD(*olddata) == IPC_M_CONNECT_TO_ME) {
 		int phoneid = IPC_GET_ARG5(*olddata);
 		
@@ -250,7 +248,7 @@
 			/* Set 'phone hash' as arg5 of response */
 			IPC_SET_ARG5(answer->data,
-			    (sysarg_t) &TASK->phones[phoneid]);
-		}
-	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_CONNECT_ME_TO) {
+			    (unative_t) &TASK->phones[phoneid]);
+		}
+	} else if (IPC_GET_METHOD(*olddata) == IPC_M_CONNECT_ME_TO) {
 		/* If the users accepted call, connect */
 		if (IPC_GET_RETVAL(answer->data) == EOK) {
@@ -258,5 +256,5 @@
 			    &TASK->answerbox);
 		}
-	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_SHARE_OUT) {
+	} else if (IPC_GET_METHOD(*olddata) == IPC_M_SHARE_OUT) {
 		if (!IPC_GET_RETVAL(answer->data)) {
 			/* Accepted, handle as_area receipt */
@@ -272,5 +270,5 @@
 			return rc;
 		}
-	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_SHARE_IN) {
+	} else if (IPC_GET_METHOD(*olddata) == IPC_M_SHARE_IN) {
 		if (!IPC_GET_RETVAL(answer->data)) { 
 			irq_spinlock_lock(&answer->sender->lock, true);
@@ -283,5 +281,5 @@
 			IPC_SET_RETVAL(answer->data, rc);
 		}
-	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_DATA_READ) {
+	} else if (IPC_GET_METHOD(*olddata) == IPC_M_DATA_READ) {
 		ASSERT(!answer->buffer);
 		if (!IPC_GET_RETVAL(answer->data)) {
@@ -312,5 +310,5 @@
 			}
 		}
-	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_DATA_WRITE) {
+	} else if (IPC_GET_METHOD(*olddata) == IPC_M_DATA_WRITE) {
 		ASSERT(answer->buffer);
 		if (!IPC_GET_RETVAL(answer->data)) {
@@ -365,5 +363,5 @@
 static int request_preprocess(call_t *call, phone_t *phone)
 {
-	switch (IPC_GET_IMETHOD(call->data)) {
+	switch (IPC_GET_METHOD(call->data)) {
 	case IPC_M_CONNECTION_CLONE: {
 		phone_t *cloned_phone;
@@ -401,5 +399,5 @@
 	}
 	case IPC_M_CONNECT_ME:
-		IPC_SET_ARG5(call->data, (sysarg_t) phone);
+		IPC_SET_ARG5(call->data, (unative_t) phone);
 		break;
 	case IPC_M_CONNECT_ME_TO: {
@@ -409,5 +407,5 @@
 		
 		/* Set arg5 for server */
-		IPC_SET_ARG5(call->data, (sysarg_t) &TASK->phones[newphid]);
+		IPC_SET_ARG5(call->data, (unative_t) &TASK->phones[newphid]);
 		call->flags |= IPC_CALL_CONN_ME_TO;
 		call->priv = newphid;
@@ -505,5 +503,5 @@
 static int process_request(answerbox_t *box, call_t *call)
 {
-	if (IPC_GET_IMETHOD(call->data) == IPC_M_CONNECT_TO_ME) {
+	if (IPC_GET_METHOD(call->data) == IPC_M_CONNECT_TO_ME) {
 		int phoneid = phone_alloc(TASK);
 		if (phoneid < 0) { /* Failed to allocate phone */
@@ -516,5 +514,5 @@
 	}
 	
-	switch (IPC_GET_IMETHOD(call->data)) {
+	switch (IPC_GET_METHOD(call->data)) {
 	case IPC_M_DEBUG_ALL:
 		return -1;
@@ -532,9 +530,9 @@
  *
  * @param phoneid Phone handle for the call.
- * @param imethod Interface and method of the call.
+ * @param method  Method of the call.
  * @param arg1    Service-defined payload argument.
  * @param arg2    Service-defined payload argument.
  * @param arg3    Service-defined payload argument.
- * @param data    Address of user-space structure where the reply call will
+ * @param data    Address of userspace structure where the reply call will
  *                be stored.
  *
@@ -543,13 +541,13 @@
  *
  */
-sysarg_t sys_ipc_call_sync_fast(sysarg_t phoneid, sysarg_t imethod,
-    sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, ipc_data_t *data)
+unative_t sys_ipc_call_sync_fast(unative_t phoneid, unative_t method,
+    unative_t arg1, unative_t arg2, unative_t arg3, ipc_data_t *data)
 {
 	phone_t *phone;
 	if (phone_get(phoneid, &phone) != EOK)
 		return ENOENT;
-	
+
 	call_t *call = ipc_call_alloc(0);
-	IPC_SET_IMETHOD(call->data, imethod);
+	IPC_SET_METHOD(call->data, method);
 	IPC_SET_ARG1(call->data, arg1);
 	IPC_SET_ARG2(call->data, arg2);
@@ -581,4 +579,5 @@
 		
 		process_answer(call);
+		
 	} else
 		IPC_SET_RETVAL(call->data, res);
@@ -594,13 +593,13 @@
 /** Make a synchronous IPC call allowing to transmit the entire payload.
  *
- * @param phoneid Phone handle for the call.
- * @param request User-space address of call data with the request.
- * @param reply   User-space address of call data where to store the
- *                answer.
+ * @param phoneid  Phone handle for the call.
+ * @param question Userspace address of call data with the request.
+ * @param reply    Userspace address of call data where to store the
+ *                 answer.
  *
  * @return Zero on success or an error code.
  *
  */
-sysarg_t sys_ipc_call_sync_slow(sysarg_t phoneid, ipc_data_t *request,
+unative_t sys_ipc_call_sync_slow(unative_t phoneid, ipc_data_t *question,
     ipc_data_t *reply)
 {
@@ -608,11 +607,11 @@
 	if (phone_get(phoneid, &phone) != EOK)
 		return ENOENT;
-	
+
 	call_t *call = ipc_call_alloc(0);
-	int rc = copy_from_uspace(&call->data.args, &request->args,
+	int rc = copy_from_uspace(&call->data.args, &question->args,
 	    sizeof(call->data.args));
 	if (rc != 0) {
 		ipc_call_free(call);
-		return (sysarg_t) rc;
+		return (unative_t) rc;
 	}
 	
@@ -648,6 +647,5 @@
  * made over a phone.
  *
- * @param phone Phone to check the limit against.
- *
+ * @param phone Phone to check the limit against. 
  * @return 0 if limit not reached or -1 if limit exceeded.
  *
@@ -667,5 +665,5 @@
  *
  * @param phoneid Phone handle for the call.
- * @param imethod Interface and method of the call.
+ * @param method  Method of the call.
  * @param arg1    Service-defined payload argument.
  * @param arg2    Service-defined payload argument.
@@ -679,16 +677,16 @@
  *
  */
-sysarg_t sys_ipc_call_async_fast(sysarg_t phoneid, sysarg_t imethod,
-    sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
+unative_t sys_ipc_call_async_fast(unative_t phoneid, unative_t method,
+    unative_t arg1, unative_t arg2, unative_t arg3, unative_t arg4)
 {
 	phone_t *phone;
 	if (phone_get(phoneid, &phone) != EOK)
 		return IPC_CALLRET_FATAL;
-	
+
 	if (check_call_limit(phone))
 		return IPC_CALLRET_TEMPORARY;
 	
 	call_t *call = ipc_call_alloc(0);
-	IPC_SET_IMETHOD(call->data, imethod);
+	IPC_SET_METHOD(call->data, method);
 	IPC_SET_ARG1(call->data, arg1);
 	IPC_SET_ARG2(call->data, arg2);
@@ -709,5 +707,5 @@
 		ipc_backsend_err(phone, call, res);
 	
-	return (sysarg_t) call;
+	return (unative_t) call;
 }
 
@@ -720,5 +718,5 @@
  *
  */
-sysarg_t sys_ipc_call_async_slow(sysarg_t phoneid, ipc_data_t *data)
+unative_t sys_ipc_call_async_slow(unative_t phoneid, ipc_data_t *data)
 {
 	phone_t *phone;
@@ -734,5 +732,5 @@
 	if (rc != 0) {
 		ipc_call_free(call);
-		return (sysarg_t) rc;
+		return (unative_t) rc;
 	}
 	
@@ -744,5 +742,5 @@
 		ipc_backsend_err(phone, call, res);
 	
-	return (sysarg_t) call;
+	return (unative_t) call;
 }
 
@@ -753,5 +751,5 @@
  * @param callid  Hash of the call to forward.
  * @param phoneid Phone handle to use for forwarding.
- * @param imethod New interface and method to use for the forwarded call.
+ * @param method  New method to use for the forwarded call.
  * @param arg1    New value of the first argument for the forwarded call.
  * @param arg2    New value of the second argument for the forwarded call.
@@ -769,7 +767,7 @@
  *
  */
-static sysarg_t sys_ipc_forward_common(sysarg_t callid, sysarg_t phoneid,
-    sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3,
-    sysarg_t arg4, sysarg_t arg5, unsigned int mode, bool slow)
+static unative_t sys_ipc_forward_common(unative_t callid, unative_t phoneid,
+    unative_t method, unative_t arg1, unative_t arg2, unative_t arg3,
+    unative_t arg4, unative_t arg5, unsigned int mode, bool slow)
 {
 	call_t *call = get_call(callid);
@@ -786,5 +784,5 @@
 	}
 	
-	if (!method_is_forwardable(IPC_GET_IMETHOD(call->data))) {
+	if (!method_is_forwardable(IPC_GET_METHOD(call->data))) {
 		IPC_SET_RETVAL(call->data, EFORWARD);
 		ipc_answer(&TASK->answerbox, call);
@@ -793,15 +791,15 @@
 	
 	/*
-	 * Userspace is not allowed to change interface and method of system
-	 * methods on forward, allow changing ARG1, ARG2, ARG3 and ARG4 by
-	 * means of method, arg1, arg2 and arg3.
-	 * If the interface and method is immutable, don't change anything.
+	 * Userspace is not allowed to change method of system methods on
+	 * forward, allow changing ARG1, ARG2, ARG3 and ARG4 by means of method,
+	 * arg1, arg2 and arg3.
+	 * If the method is immutable, don't change anything.
 	 */
-	if (!method_is_immutable(IPC_GET_IMETHOD(call->data))) {
-		if (method_is_system(IPC_GET_IMETHOD(call->data))) {
-			if (IPC_GET_IMETHOD(call->data) == IPC_M_CONNECT_TO_ME)
+	if (!method_is_immutable(IPC_GET_METHOD(call->data))) {
+		if (method_is_system(IPC_GET_METHOD(call->data))) {
+			if (IPC_GET_METHOD(call->data) == IPC_M_CONNECT_TO_ME)
 				phone_dealloc(IPC_GET_ARG5(call->data));
 			
-			IPC_SET_ARG1(call->data, imethod);
+			IPC_SET_ARG1(call->data, method);
 			IPC_SET_ARG2(call->data, arg1);
 			IPC_SET_ARG3(call->data, arg2);
@@ -815,5 +813,5 @@
 			}
 		} else {
-			IPC_SET_IMETHOD(call->data, imethod);
+			IPC_SET_METHOD(call->data, method);
 			IPC_SET_ARG1(call->data, arg1);
 			IPC_SET_ARG2(call->data, arg2);
@@ -831,14 +829,14 @@
 /** Forward a received call to another destination - fast version.
  *
- * In case the original interface and method is a system method, ARG1, ARG2
- * and ARG3 are overwritten in the forwarded message with the new method and
- * the new arg1 and arg2, respectively. Otherwise the IMETHOD, ARG1 and ARG2
- * are rewritten with the new interface and method, arg1 and arg2, respectively.
- * Also note there is a set of immutable methods, for which the new method and
- * arguments are not set and these values are ignored.
+ * In case the original method is a system method, ARG1, ARG2 and ARG3 are
+ * overwritten in the forwarded message with the new method and the new
+ * arg1 and arg2, respectively. Otherwise the METHOD, ARG1 and ARG2 are
+ * rewritten with the new method, arg1 and arg2, respectively. Also note there
+ * is a set of immutable methods, for which the new method and arguments are not
+ * set and these values are ignored.
  *
  * @param callid  Hash of the call to forward.
  * @param phoneid Phone handle to use for forwarding.
- * @param imethod New interface and method to use for the forwarded call.
+ * @param method  New method to use for the forwarded call.
  * @param arg1    New value of the first argument for the forwarded call.
  * @param arg2    New value of the second argument for the forwarded call.
@@ -848,8 +846,8 @@
  *
  */
-sysarg_t sys_ipc_forward_fast(sysarg_t callid, sysarg_t phoneid,
-    sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, unsigned int mode)
-{
-	return sys_ipc_forward_common(callid, phoneid, imethod, arg1, arg2, 0, 0,
+unative_t sys_ipc_forward_fast(unative_t callid, unative_t phoneid,
+    unative_t method, unative_t arg1, unative_t arg2, unsigned int mode)
+{
+	return sys_ipc_forward_common(callid, phoneid, method, arg1, arg2, 0, 0,
 	    0, mode, false); 
 }
@@ -858,9 +856,9 @@
  *
  * This function is the slow verision of the sys_ipc_forward_fast interface.
- * It can copy all five new arguments and the new interface and method from
- * the userspace. It naturally extends the functionality of the fast version.
- * For system methods, it additionally stores the new value of arg3 to ARG4.
- * For non-system methods, it additionally stores the new value of arg3, arg4
- * and arg5, respectively, to ARG3, ARG4 and ARG5, respectively.
+ * It can copy all five new arguments and the new method from the userspace.
+ * It naturally extends the functionality of the fast version. For system
+ * methods, it additionally stores the new value of arg3 to ARG4. For non-system
+ * methods, it additionally stores the new value of arg3, arg4 and arg5,
+ * respectively, to ARG3, ARG4 and ARG5, respectively.
  *
  * @param callid  Hash of the call to forward.
@@ -872,5 +870,5 @@
  *
  */
-sysarg_t sys_ipc_forward_slow(sysarg_t callid, sysarg_t phoneid,
+unative_t sys_ipc_forward_slow(unative_t callid, unative_t phoneid,
     ipc_data_t *data, unsigned int mode)
 {
@@ -879,8 +877,8 @@
 	    sizeof(newdata.args));
 	if (rc != 0)
-		return (sysarg_t) rc;
+		return (unative_t) rc;
 	
 	return sys_ipc_forward_common(callid, phoneid,
-	    IPC_GET_IMETHOD(newdata), IPC_GET_ARG1(newdata),
+	    IPC_GET_METHOD(newdata), IPC_GET_ARG1(newdata),
 	    IPC_GET_ARG2(newdata), IPC_GET_ARG3(newdata),
 	    IPC_GET_ARG4(newdata), IPC_GET_ARG5(newdata), mode, true); 
@@ -902,6 +900,6 @@
  *
  */
-sysarg_t sys_ipc_answer_fast(sysarg_t callid, sysarg_t retval,
-    sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
+unative_t sys_ipc_answer_fast(unative_t callid, unative_t retval,
+    unative_t arg1, unative_t arg2, unative_t arg3, unative_t arg4)
 {
 	/* Do not answer notification callids */
@@ -947,5 +945,5 @@
  *
  */
-sysarg_t sys_ipc_answer_slow(sysarg_t callid, ipc_data_t *data)
+unative_t sys_ipc_answer_slow(unative_t callid, ipc_data_t *data)
 {
 	/* Do not answer notification callids */
@@ -984,5 +982,5 @@
  *
  */
-sysarg_t sys_ipc_hangup(sysarg_t phoneid)
+unative_t sys_ipc_hangup(unative_t phoneid)
 {
 	phone_t *phone;
@@ -1010,5 +1008,5 @@
  *
  */
-sysarg_t sys_ipc_wait_for_call(ipc_data_t *calldata, uint32_t usec,
+unative_t sys_ipc_wait_for_call(ipc_data_t *calldata, uint32_t usec,
     unsigned int flags)
 {
@@ -1039,5 +1037,5 @@
 		ipc_call_free(call);
 		
-		return ((sysarg_t) call) | IPC_CALLID_NOTIFICATION;
+		return ((unative_t) call) | IPC_CALLID_NOTIFICATION;
 	}
 	
@@ -1053,5 +1051,5 @@
 		ipc_call_free(call);
 		
-		return ((sysarg_t) call) | IPC_CALLID_ANSWERED;
+		return ((unative_t) call) | IPC_CALLID_ANSWERED;
 	}
 	
@@ -1081,5 +1079,5 @@
 	}
 	
-	return (sysarg_t) call;
+	return (unative_t) call;
 }
 
@@ -1087,5 +1085,5 @@
  *
  */
-sysarg_t sys_ipc_poke(void)
+unative_t sys_ipc_poke(void)
 {
 	waitq_unsleep(&TASK->answerbox.wq);
@@ -1095,13 +1093,13 @@
 /** Connect an IRQ handler to a task.
  *
- * @param inr     IRQ number.
- * @param devno   Device number.
- * @param imethod Interface and method to be associated with the notification.
- * @param ucode   Uspace pointer to the top-half pseudocode.
+ * @param inr    IRQ number.
+ * @param devno  Device number.
+ * @param method Method to be associated with the notification.
+ * @param ucode  Uspace pointer to the top-half pseudocode.
  *
  * @return EPERM or a return code returned by ipc_irq_register().
  *
  */
-sysarg_t sys_ipc_register_irq(inr_t inr, devno_t devno, sysarg_t imethod,
+unative_t sys_ipc_register_irq(inr_t inr, devno_t devno, unative_t method,
     irq_code_t *ucode)
 {
@@ -1109,5 +1107,5 @@
 		return EPERM;
 	
-	return ipc_irq_register(&TASK->answerbox, inr, devno, imethod, ucode);
+	return ipc_irq_register(&TASK->answerbox, inr, devno, method, ucode);
 }
 
@@ -1120,5 +1118,5 @@
  *
  */
-sysarg_t sys_ipc_unregister_irq(inr_t inr, devno_t devno)
+unative_t sys_ipc_unregister_irq(inr_t inr, devno_t devno)
 {
 	if (!(cap_get(TASK) & CAP_IRQ_REG))
@@ -1130,45 +1128,27 @@
 }
 
-#ifdef __32_BITS__
-
-/** Syscall connect to a task by ID (32 bits)
+#include <console/console.h>
+
+/** Syscall connect to a task by id.
  *
  * @return Phone id on success, or negative error code.
  *
  */
-sysarg_t sys_ipc_connect_kbox(sysarg64_t *uspace_taskid)
+unative_t sys_ipc_connect_kbox(sysarg64_t *uspace_taskid_arg)
 {
 #ifdef CONFIG_UDEBUG
-	sysarg64_t taskid;
-	int rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(sysarg64_t));
+	sysarg64_t taskid_arg;
+	int rc = copy_from_uspace(&taskid_arg, uspace_taskid_arg, sizeof(sysarg64_t));
 	if (rc != 0)
-		return (sysarg_t) rc;
-	
-	return ipc_connect_kbox((task_id_t) taskid);
+		return (unative_t) rc;
+	
+	LOG("sys_ipc_connect_kbox(%" PRIu64 ")", taskid_arg.value);
+	
+	return ipc_connect_kbox(taskid_arg.value);
 #else
-	return (sysarg_t) ENOTSUP;
+	return (unative_t) ENOTSUP;
 #endif
 }
 
-#endif  /* __32_BITS__ */
-
-#ifdef __64_BITS__
-
-/** Syscall connect to a task by ID (64 bits)
- *
- * @return Phone id on success, or negative error code.
- *
- */
-sysarg_t sys_ipc_connect_kbox(sysarg_t taskid)
-{
-#ifdef CONFIG_UDEBUG
-	return ipc_connect_kbox((task_id_t) taskid);
-#else
-	return (sysarg_t) ENOTSUP;
-#endif
-}
-
-#endif  /* __64_BITS__ */
-
 /** @}
  */